import datetime

def days_1950(date_num):
    """Convert Matlab serial date number to number of days since Jan 1st
    1950.

    """
    date = datetime.date.fromordinal(date_num - 366) - datetime.date(1950, 1, 1)
    return date.days

def convert_id(node_index, e_overestim, d1):
    """Convert from node identification in graph to eddy identification in
    shapefiles.

    """
    k = (node_index - 1) // e_overestim
    eddy_index = node_index - k * e_overestim
    return d1 + k, eddy_index
