module unit_edge_m

  implicit none

  integer, protected:: unit_edge_cyclo = - huge(0), unit_edge_anti = - huge(0)
  ! logical unit numbers for files containing edge lists

contains

  subroutine open_edge_file(rank)

    use jumble, only: new_unit

    integer, intent(in):: rank

    ! Local:
    character(len = 30) file

    !--------------------------------------------------------------

    call new_unit(unit_edge_cyclo)
    write(unit = file, fmt = '("edgelist_cyclo_", i0, ".csv")') rank
    open(unit_edge_cyclo, file = trim(file), status = "replace", &
         action  = "write")

    call new_unit(unit_edge_anti)
    write(unit = file, fmt = '("edgelist_anti_", i0, ".csv")') rank
    open(unit_edge_anti, file = trim(file), status = "replace", &
         action  = "write")

  end subroutine open_edge_file
  
end module unit_edge_m
